#include <cstdlib>
#include <iostream>
#include <sstream>

using namespace std;

const int maxn = 1000001;

int a[maxn], b[maxn], perm[maxn];

int mrand(int x)
{
    return (rand()*(unsigned int)rand() + rand()) % x;
}

int main(int argc, char* argv[])
{
    int n, kernel, randseed;
    istringstream ss1(argv[1]);
    ss1 >> n;
    istringstream ss2(argv[2]);
    ss2 >> kernel;
    istringstream ss3(argv[3]);
    ss3 >> randseed;

    srand(randseed);

    int i;
    a[1] = kernel == 1 ? 0 : kernel;
    for (i = 2; i <= kernel; i++)
        a[i] = i-1;
    for (i = kernel+1; i <= n; i++)
        a[i] = 1 + mrand(i-1);

    for (i = 1; i <= n; i++)
        perm[i] = i;
    for (i = 1; i <= n; i++)
        swap(perm[mrand(n)+1], perm[mrand(n)+1]);

    for (i = 1; i <= n; i++)
        b[perm[i]] = perm[a[i]];

    cout << n << endl;
    for (i = 1; i <= n; i++)
        cout << b[i] << " ";
    cout << endl;

    return 0;
}
