#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <cctype>
#include <sstream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <queue>

using namespace std;

const int maxn = 1000001;

int n;
int a[maxn], vis[maxn];
long long best;
int best_i, best_j;

long long calc()
{
    long long res = 0;
    for (int i = 1; i <= n; i++) {
        memset(vis, 0, sizeof(vis));
        int k = i;
        while (!vis[k]) {
            vis[k] = 1;
            res++;
            k = a[k];
        }
    }
    return res;
}

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);

    int i, j;

    scanf("%d", &n);
    for (i = 1; i <= n; i++) {
        scanf("%d", &a[i]);
        if (!a[i]) a[i] = i;
    }

    best = calc();
    best_i = best_j = 0;

    for (i = 1; i <= n; i++) {
        for (j = 1; j <= n; j++) {
            int t = a[i];
            a[i] = j;
            long long cur = calc();
            a[i] = t;
            if (cur > best) {
                best_i = i;
                best_j = j;
                best = cur;
            }
        }
    }

    cout << best_i << " " << best_j << endl;

    fclose(stdin); fclose(stdout);
    return 0;
}
